@mixin clearfix {
    &::before,
    &::after {
        content: "";
        display: table;
        clear: both;
    }
}

// /* Static Column Grid
//
// Usage
// 
// @include build-column-grid($site-column-count);

$default-margin: ((2 * $default-gutter) / ($base-width - (2 * $default-gutter)) / 0.01);
$singleColWidth: (100 - ($default-margin * ($site-column-count - 1))) / $site-column-count;

@mixin build-column-grid($columns) {
    @for $i from 1 to $columns + 1 {
        @if $i != $columns {
            > .col-#{$i} {
                width: ($singleColWidth * $i) + ($default-margin * ($i - 1)) + %;

                &.centered {
                    margin-left: (100 - (($singleColWidth * $i) + ($default-margin * ($i - 1)))) / 2 + %;
                }
            } 
        } @else {
            > .col-#{$i} {
                width: 100%;
            }
        }      
    }
    
    @for $i from 1 to $columns + 1 {
        @if $i != $columns {
            [class^=col-].push-#{$i} {
                margin-left: ($singleColWidth * $i) + ($default-margin * ($i - 1)) + $default-margin + %;
            } 
        }       
    }
}

// /* Flex Grid
//
// Usage
// 
// @each $modifier, $breakpoint in $map-grid-props {
//   @include build-flex-grid-classes($modifier, $site-column-count, $breakpoint);
// }

$map-grid-props: (
    '': 0,
    '-xs': $screen-xs-min,
    '-sm': $screen-sm-min,
    '-md': $screen-md-min,
    '-lg': $screen-lg-min,
    '-xl': $screen-xl-min
);

@mixin create-mq($breakpoint) {
  @if($breakpoint == 0) {
    @content;
  } @else {
    @media screen and (min-width: $breakpoint *1px) {
      @content;
    }
  }
}

@mixin build-flex-grid-classes($modifier, $site-column-count, $breakpoint) {
  @include create-mq($breakpoint) {
    @for $i from 1 through $site-column-count {
      .flex#{$modifier}-#{$i} {
        flex-basis: (100 / ($site-column-count / $i) ) * 1%;
      }
      .flex#{$modifier}.push-#{$i} {
        margin-left: (100 / ($site-column-count / $i) ) * 1%;
      }
    }
  }
}

// /* -- REM --
//  converts all units to rem with px fallback.

//  Usage:

//  Input:

//  element {
//    @include rem('font-size', 14px);
//    @include rem('margin', 20px 10px);
//    @include rem('padding', 10px 0 0 10px);
//  }

//  Output:

//  element {
//    font-size: 14px;
//    font-size: 1.4em;
//    margin: 20px 10px;
//    margin: 2em 1em;
//    padding: 10px 0 0 10px;
//    padding: 1em 0 0 1em;
//  }*/

@mixin rem($attr, $px-values) {
    $baseline-rem: 10px / 1rem * 1;
    #{$attr}: $px-values;

    $rem-values: ();

    @each $value in $px-values {
        @if $value == 0 or type-of( $value ) != "number" {
            $rem-values: append($rem-values, $value);
        } @else {
            $rem-values: append($rem-values, $value / $baseline-rem);
        }
    }

    #{$attr}: $rem-values;
}

@mixin border-radius($radius) {
    /*-webkit-border-radius: $radius;
    -moz-border-radius: $radius;*/
    -ms-border-radius: $radius;
    border-radius: $radius;
}

// /* Opacity should be on a 100 point scale (0-100 instead of 0.0-1.0)
//  This should be used to supplement a normal border definition as it
//  only deals with the 'border-color' property.*/
@mixin opacity($attr, $color, $opacity) {
    $opacity: $opacity / 100;

    //  @if type-of($attr) == "border-color" {
    //    // Prevent the element's background from reaching the edge of the border
    //    -moz-background-clip: padding;
    //    -webkit-background-clip: padding;
    //    background-clip: padding-box;
    //  }

    #{$attr}: $color;
    #{$attr}: rgba($color, $opacity);
}


// -- Respond-to --
//
// Usage
//
// @include respond-to(xs) { @content; }
// @include respond-to(sm) { @content; }
// @include respond-to(md) { @content; }
// @include respond-to(lg) { @content; }
// @include respond-to(xl) { @content; }


@mixin respond-to($media) {
    @if $media == zero {
        @media ( min-width: $screen-min * 1px ) { @content; } // Tiny devices
    }
    @else if $media == xs {
        @media ( min-width: $screen-xs-min * 1px ) { @content; } // Tiny devices
    }
    @else if $media == sm {
        @media ( min-width: $screen-sm-min * 1px ) { @content; } // Small devices
    }
    @else if $media == md {        
        @media ( min-width: $screen-md-min * 1px ) { @content; } // Medium devices
    }
    @else if $media == lg {
        @media ( min-width: $screen-lg-min * 1px ) { @content; } // Large devices
    }
    @else if $media == xl {
        @media ( min-width: $screen-xl-min * 1px ) { @content; } // Extra large devices
    }
}